#!/usr/bin/perl -T
# $Id: main.cgi,v 1.31 2015/06/17 06:47:30 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use SocketClient;
use CGI qw(:standard :netscape);
use Sys::Hostname;

my $hostname = hostname;
my $pwdhost = get_cv('passwds','passwd_server');

my $isadmin = 0;
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    my $uid = &RFC::Main::passwd_client('pwdstatus',&get_id());
    $isadmin = &is_admin();
    if ($uid)
    { 
	print_header("$name main page");
	print RFC_start_html(-title=>"$name main page", -style=>{src=>'/celltest/RFCcontrol.css'});
	top_nav_bar_start();
	if ($isadmin)
	{
	    top_nav_bar_button('confmanage.cgi','','','Global configuration','s0');
	    top_nav_bar_button('usermanage.cgi','','','User management','s1');
	}
	else
	{
	    if ($hostname eq $pwdhost)
	    {
		top_nav_bar_button('task.cgi','','','Manage safty clearances','s3');
	    }
	    else
	    {
		top_no_button;
	    }
	    top_no_button;
	}
	my $acmode = &get_cv('global','access_mode');
	$acmode = 'celltest' unless ($acmode);
	if (&user_auth($acmode,'r'))
	{
	    top_nav_bar_button('search_reports.cgi','','','Search reports','s6');
	}
	else
	{
	    top_no_button();
	}
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	&top_nav_bar_button('util.cgi','','','Utilities','s7');
	&top_nav_bar_button('changepwd.cgi','','','Change password','s6');
	&top_nav_bar_button('about.cgi','','','About','s5');
	## Specproc for derect access to labysstem, remoove if no labsystem ####
	## top_no_button();
	my $server = get_cv('passwds','passwd_server');
	if (CGI::https())
	{
	    &top_nav_bar_button('https://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	}
	else
	{
	    &top_nav_bar_button('http://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	}
	## End specproc
	&end_top_bar;
        if ($uid =~ /RESET/)
        {
            print center(h2({-class=>'Alert'},"You must change your password!"));
        }
	elsif ($uid =~ /EXPIRE/)
	{
	    print center(h2({-class=>'Alert'},"Your password has expired, Please change password"));
	}
        else
        {
	    &main_page;
	}
	&print_end();
    }
    else 
    {
	&not_auth;
    }
}
    
exit;


sub main_page
{
    print '<center>';
    my $server = `/bin/hostname`;
    $server =~ /([\w\-]+)/;
    $server = $1;
    my @list = ();
    my @listservers = ();
    my $listserver = get_cv('servers','listserver');
    if ($listserver)
    {
        chomp $listserver;
        my $str= &RFC::Main::report_client($listserver,'servers');
        my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
        foreach (@l)
        {
            if (/([\w\.\-]+)/)
            {
                push @list,$1;
            }
        }
        my $str= &RFC::Main::report_client($listserver,'list_servers');
        my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
        foreach (@l)
        {
            if (/([\w\.\-]+)/)
            {
                push @listservers,$1;
            }
        }
    }
    if (@listservers && @listservers > 1)
    {
	print h3("Avaliable listservers");
	print '<table border=0 cellspacing=10 cellpadding=0><tr>';
	foreach my $s (sort @listservers)
	{
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/main.cgi');
	    }
	    &print_hidden();
	    &menu_button('test',$s,'s1');
	    print end_form();
	    print '</td>';
	}
	print '</tr></table>';
    }
    if (@list)
    {
	print h3("Avaliable servers and rigs on listserver $listserver");
	print '<table border=0 cellspacing=10 cellpadding=0>';
	foreach my $s (sort @list)
	{
	    print '<tr>';
	    my $str = &RFC::Main::report_client($s,'active_rigs');
	    my @l = ();
	    @l = split(/\t/,$str) if ($str);
	    if ($isadmin)
	    {
		print '<td>';
		if (CGI::https())
		{
		    print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/confmanage.cgi');
		}
		else
		{
		    print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/confmanage.cgi');
		}
		&print_hidden();
		&menu_button('test',"Configure $s",'s1');
		print end_form();
		print '</td>';
		print '<td width=10>';
		print '</td>';
	    }
	    else
	    {
		print '<th>';
		print $s;
		print ': </th>';
	    }
	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not get rig numbers from '$s'</th>";
		&errorlog($l[0]);
		next;
	    }
	    foreach my $r (sort {$a <=> $b} @l)
	    {
		next unless ($r && $r =~ /\d/);
		print '<td>';
		if ($s eq $server)
		{
		    print start_form(-action=>'/cgi-bin/celltest/rig_main.cgi');
		}
		else
		{
		    if (CGI::https())
		    {
			print start_form(-action=>'https://'.$s.'/cgi-bin/celltest/rig_main.cgi');
		    }
		    else
		    {
			print start_form(-action=>'http://'.$s.'/cgi-bin/celltest/rig_main.cgi');
		    }
		}
		&print_hidden();
		print hidden(-name=>'rig',-value=>$r,-force=>1);
		&menu_button('test',"Rig $r",'s0');
		print end_form();
		print '</td>';
	    }
	    print '</tr>';
	}
    }
    else
    {
        print h3({-class=>'Alert'},"Error: Could not get server list from from '$listserver', using local list only");
        print '<table border=0 cellspacing=10 cellpadding=10>';
        print '<tr><td colspan=10 class="heading">';
        print "Data on all test stations:";
        print '</td></tr><tr>';
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} @l)
        {
	    print '<td>';
	    print start_form(-action=>'/cgi-bin/celltest/rig_main.cgi');
	    &print_hidden();
	    print hidden(-name=>'rig',-value=>$r,-force=>1);
	    &menu_button('test',"Rig $r",'s0');
	    print end_form();
	    print '</td>';
        }
    }
    print '</table>';
    print p();
    print '<table border=0 cellspacing=10 cellpadding=10>';
    print '<tr><td colspan=10 class="heading">';
    print "Data on all test stations on listserver $listserver:";
    print '</td></tr>';
    if (@list)
    {
	foreach my $s (sort @list)
	{
	    print '<tr>';
	    my $str = &RFC::Main::report_client($s,'rigs');
	    my @l = ();
	    @l = split(/\t/,$str) if ($str);
	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not get rig numbers from '$s'</th>";
		&errorlog($l[0]);
		print '</tr>';
		next;
	    }
	    foreach my $r (sort {$a <=> $b} @l)
	    {
		next unless ($r && $r =~ /\d/);
		print '<td>';
		if ($s eq $server)
		{
		    print start_form(-action=>'/rig'.$r.'/',-method=>'GET');
		}
		else
		{
		    if (CGI::https())
		    {
			print start_form(-action=>'https://'.$s.'/rig'.$r.'/',-method=>'GET');
		    }
		    else
		    {
			print start_form(-action=>'http://'.$s.'/rig'.$r.'/',-method=>'GET');
		    }
		}
		&menu_button('test',"Rig $r",'s0');
		print end_form();
		print '</td>';
	    }
	    print '</tr>';
	}
    }
    else
    {
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} (@l))
        {
	    next unless ($r && $r =~ /\d/);
            print '<td>';
            print start_form(-action=>'/rig'.$r.'/',-method=>'GET');
            menu_button('test',"Rig $r",'s0');
            print end_form();
            print '</td>';
        }
    }
    print '</table>';
    print '</center>';
}
